/*
 * Counter.java
 *
 * Created on 12. prosinec 2007, 16:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package counter;

/**
 *
 * @author Tomas
 */
public class Counter
{
    
    /** Creates a new instance of Counter */
    public Counter()
    {
    }
    
    /**
     * Holds value of property count.
     */
    private int count;
    
    /**
     * Getter for property count.
     * @return Value of property count.
     */
    public int getCount()
    {
        return this.count;
    }
    
    /**
     * Setter for property count.
     * @param count New value of property count.
     */
    public void setCount(int count)
    {
        this.count = count;
    }
    
    public void increment()
    {
        CounterEvent evt = new CounterEvent(this, count);
        count++;
        fireCounterListenerCounterIncrementEvent(evt);
    }
    
    public void decrement()
    {
        CounterEvent evt = new CounterEvent(this, count);
        count--;
        fireCounterListenerCounterDecrementEvent(evt);
    }
    
    public void reset()
    {
        CounterEvent evt = new CounterEvent(this, count);
        count = 0;
        fireCounterListenerCounterResetEvent(evt);
    }
    
    /**
     * Utility field used by event firing mechanism.
     */
    private javax.swing.event.EventListenerList listenerList =  null;
    
    /**
     * Registers CounterListener to receive events.
     * @param listener The listener to register.
     */
    public synchronized void addCounterListener(counter.CounterListener listener)
    {
        if (listenerList == null )
        {
            listenerList = new javax.swing.event.EventListenerList();
        }
        listenerList.add(counter.CounterListener.class, listener);
    }
    
    /**
     * Removes CounterListener from the list of listeners.
     * @param listener The listener to remove.
     */
    public synchronized void removeCounterListener(counter.CounterListener listener)
    {
        listenerList.remove(counter.CounterListener.class, listener);
    }
    
    /**
     * Notifies all registered listeners about the event.
     *
     * @param event The event to be fired
     */
    private void fireCounterListenerCounterResetEvent(counter.CounterEvent event)
    {
        if (listenerList == null) return;
        Object[] listeners = listenerList.getListenerList();
        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            if (listeners[i]==counter.CounterListener.class)
            {
                ((counter.CounterListener)listeners[i+1]).counterResetEvent(event);
            }
        }
    }
    
    /**
     * Notifies all registered listeners about the event.
     *
     * @param event The event to be fired
     */
    private void fireCounterListenerCounterIncrementEvent(counter.CounterEvent event)
    {
        if (listenerList == null) return;
        Object[] listeners = listenerList.getListenerList();
        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            if (listeners[i]==counter.CounterListener.class)
            {
                ((counter.CounterListener)listeners[i+1]).counterIncrementEvent(event);
            }
        }
    }
    
    /**
     * Notifies all registered listeners about the event.
     *
     * @param event The event to be fired
     */
    private void fireCounterListenerCounterDecrementEvent(counter.CounterEvent event)
    {
        if (listenerList == null) return;
        Object[] listeners = listenerList.getListenerList();
        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            if (listeners[i]==counter.CounterListener.class)
            {
                ((counter.CounterListener)listeners[i+1]).counterDecrementEvent(event);
            }
        }
    }
    
}
